#define PARAM_LEN    512
#define NAME_LEN     64
#define TEXT_LEN     2048

struct tag_param;
/* structure for a tag argument */
struct tag_param
{
  char pname[NAME_LEN];     /* argument's name */
  char pvalue[PARAM_LEN];   /* argument's value */
  struct tag_param *pnext;  /* pointer to next argument */
};

/* struct for registering a tag */
struct tag_struct
{
  char tname[NAME_LEN];         /* tag's name */
  struct tag_param *tparams;    /* pointer to tag's arguments */
};

