import java.io.*;

public class calc_jav
{
/*
All tables are extracted from generated .c file.
They are positioned at place $T (in the beginning of
Java skeleton file) is found by the
tool program. These tables are readonly. So it
is best to declare them as static constants.
In .c file, they are const int array.
*/
private static final int yyexca[] = {
  -1, 1,
  0, -1,
  -2, 0,
  0,
};

private static final int yyact[] = {
       7,      13,       1,       0,       0,       6,      11,       9,
       7,      10,       0,      12,      11,       6,      20,      11,
       9,      12,      10,       3,      12,       0,       0,       0,
       0,       0,      14,      15,       0,      16,      17,      18,
      19,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       4,       2,       5,       0,       0,       8,       0,       0,
       0,       0,       5,
};

private static final int yypact[] = {
   -4096,     -40,   -4096,     -36,    -256,   -4096,     -32,     -32,
   -4096,     -32,     -32,     -32,     -32,   -4096,   -4096,     -27,
     -30,     -30,   -4096,   -4096,   -4096,
};

private static final int yypgo[] = {
       0,       2,      19,
};

private static final int yyr1[] = {
       0,       1,       1,       1,       1,       2,       2,       2,
       2,       2,       2,       2,
};

private static final int yyr2[] = {
       0,       0,       2,       3,       3,       1,       2,       3,
       3,       3,       3,       3,
};

private static final int yychk[] = {
   -4096,      -1,     257,      -2,     256,     258,      45,      40,
     257,      43,      45,      42,      47,     257,      -2,      -2,
      -2,      -2,      -2,      -2,      41,
};

private static final int yydef[] = {
       1,      -2,       2,       0,       0,       5,       0,       0,
       3,       0,       0,       0,       0,       4,       6,       0,
       7,       8,       9,      10,      11,
};

/*
These are constants representing tokens. In .c file,
they are macro definitions. All the macro definitions
could be converted to this form of declarations.
It is possible for the tool program to transform the
conditional compilation code in .c file into if 
statement in JAVA. In this way, we can keep the 
debugging code in generated .c code.
*/
  private static final int STAND_ALONE = 1;
  private static final int QUIT = 101010;
  private static final int LF = 0x0a;
  private static final int CR = 0xd;
  private static final int NEWLINE = 257;
  private static final int NUMBER = 258;
  private static final int UNARYMINUS = 259;
  private static final int YYERRCODE = 256;
  private static final int YYNPROD = 12;
  private static final int YYLAST = 227;
  private static final int YYMAXDEPTH = 200;
  private static final int YYREDMAX = 1000;
  private static final int PCYYFLAG = -4096;
  private static final int WAS0ERR = 0;
  private static final int WAS1ERR = 1;
  private static final int WAS2ERR = 2;
  private static final int WAS3ERR = 3;
  private static final int yyclearin = -1;
  private static final int yyerrok = 0;

public static void main(String args[])
{
  if (args.length>0)
    System.out.println("nonmeaningful arguments");

  System.out.println("*************************************************");
  System.out.println("*  SACALC: A Simple Arithmetic Calculator       *");
  System.out.println("*                                               *");
  System.out.println("*  1) at the prompt READY>                      *");
  System.out.println("*     you type in an expression, e.g. 1+2<CR>   *");
  System.out.println("*     SACALC will evaluate the expression       *");
  System.out.println("*     and the result is displayed               *");
  System.out.println("*  2) to terminate the program                  *");
  System.out.println("*     type QUIT                                 *");
  System.out.println("*  3) if you make a mistake                     *");
  System.out.println("*     SACALC will complain and start over again *");
  System.out.println("*                                               *");
  System.out.println("*************************************************");
  
  yyparse();

  System.out.println("*************************************************");
  System.out.println("*  SACALC: A Simple Arithmetic Calculator       *");
  System.out.println("*                                               *");
  System.out.println("*  normal termination -- bye!                   *");
  System.out.println("*************************************************");
}

private static PushbackInputStream in = 
  new PushbackInputStream(System.in);

private static int yylex()
{
  int c = 0;
  double intpart = 0;
  double decpart = 0;
  int deccnt = 0;

  try
  {
    c = in.read();      // the try and catch pair can be put on whole 
  }                     // function body to reduce the number of the pairs.
  catch (IOException e)
  {
    System.out.println(e);
	System.exit(-1);
  }

  while (c == ' ' || c == '\t' )
  {
    try
	{
	  c = in.read();
	}
	catch (IOException e)
	{
	  System.out.println(e);
	  System.exit(-1);
	}
  } 

  if (c == -1)
    return 0;

  if (c == '.' || c <= '9' && c >= '0')
  {
    if (c == '.')
	{
	  try
	  {
	    c = in.read();
	  }
	  catch (IOException e)
	  {
	    System.out.println(e);
		System.exit(-1);
	  }

	  if (c > '9' || c < '0')
	  {
	    try
		{
		  in.unread(c);
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}
		return '?';
	  }

      while (c <='9' && c >= '0')
	  {
	    decpart = decpart * 10 + c -'0';
		deccnt++;
		try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}
	  }

	  try
	  {
	    in.unread(c);
	  }
	  catch (IOException e)
	  {
	    System.out.println(e);
		System.exit(-1);
	  }

	  for (int k=0; k<deccnt; k++)
	  {
	    decpart = decpart/10;
	  }

	  yylval.db = decpart;
	}
	else
	{
	  while (c<='9' && c>='0')
	  {
	    intpart = intpart * 10 + c - '0';
		try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
	  System.exit(-1);
		}
	  }

	  if (c == '.')
	  {
	    deccnt = 0;
		try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}

		if (c>'9' || c<'0')
		{
		  yylval.db = intpart;
		  try
		  {
		    in.unread(c);
		  }
		  catch(IOException e)
		  {
		    System.out.println(e);
			System.exit(-1);
		  }
		}
		else
		{
		  while (c>='0' && c<='9')
		  {
		    decpart = decpart * 10 + c - '0';
			deccnt++;
			try
			{
			  c = in.read();
			}
			catch (IOException e)
			{
			  System.out.println(e);
			  System.exit(-1);
			}
		  }

		  try
		  {
		    in.unread(c);
		  }
		  catch (IOException e)
		  {
		    System.out.println(e);
			System.exit(-1);
		  }

		  for (int k=0; k<deccnt; k++)
		  {
		    decpart = decpart/10;
		  }

		  yylval.db = intpart + decpart;
		}
	  }
	  else
	  {
	    try
		{
		  in.unread(c);
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}

		yylval.db = intpart;
	  }
	}
	return NUMBER;
  }

  if ( c==LF || c==CR )
  {
    if ( c == CR ) c = LF;
    pcyylineno++;
    return( NEWLINE );
  }
   
  if (c=='Q' || c == 'q')
  {
    try
	{
	  c = in.read();
	}
	catch (IOException e)
	{
	  System.out.println(e);
	  System.exit(-1);
	}

	if (c=='U' || c == 'u')
	{
	  try
	  {
	    c = in.read();
	  }
	  catch (IOException e)
	  {
	    System.out.println(e);
		System.exit(-1);
	  }

	  if (c=='I' || c=='i')
	  {
	    try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}

		if (c=='T' || c== 't')
		{
		  yylval.db = QUIT;
		  return -1;
		}
		else
		{
		  return '?';
		}
		
	  }
	  else
	  {
	    return '?';
	  }
	}
	else
	{
	  return '?';
	}
  }

  return c;
}


private static void prompt()
{
  System.out.print("READY> ");
  System.out.flush();
}

private static void yyerror(String s, String t)
{
	System.out.println(s+" near line " + pcyylineno);
}

private static String yydisplay(int ch)
{
	int i=0, tok_index = 0;
	int tok_num = 2;
	String[] tok = new String[tok_num]; 

	tok[tok_index++] = "NEWLINE";
	tok[tok_index++] = "NUMBER";

    switch (ch)
    {
        case             0:   return ("[end of file]");
		case          '\b':   return (    "'\\b'"    );
		case          '\f':   return (    "'\\f'"    );
		case          '\n':   return (    "'\\n'"    );
		case          '\r':   return (    "'\\r'"    );
		case          '\t':   return (    "'\\t'"    );
		case     YYERRCODE:   return (   "[error]"   );
    }

    if(ch > YYERRCODE && ch <= YYERRCODE + tok_num)
    {
        return (tok[ch - (YYERRCODE + 1)]);                  /* is %token */
    }
    return "char \""+(char)ch+"\"";
}

// These fields are declared in Skeleton for Java.
private static imp_union yylval = new imp_union();
private static imp_union yyval = new imp_union();
private static int pcyyerrfl=0;
private static int pcyyerrcnt=0;
private static int pcyytoken=-1;

private static String pcyyerrsrc;

private static int pcyylineno;

private static void set_input_file_name(String fname)
{
	 pcyyerrsrc = fname;
}

private static int yyparse()
{
    int yyxi=0;
    int yyps=-1;    // index for accessing state stack.
    int yypv=-1;    // index for accessing value stack.
    int yypvt=0;
    int j;
    int m;
    int n;
    int tempstate=0;
    int statestack[]=new int[YYMAXDEPTH];

    imp_union[] yyv = new imp_union[YYMAXDEPTH];

enstack:
    while (true)    // psudo loop for removing goto enstack.
    {
        if (++yyps>YYMAXDEPTH-1)
        {
            yyerror("pcyacc internal stack overflow","");
            return 1;
        }
        statestack[yyps]=tempstate;
        yypv++;
		 if (yyval==null)
			yyv[yypv] = yyval;
		 else
			yyv[yypv]=(imp_union)yyval.clone();
newstate:
        while (true)    // psudo loop for removing goto newestate
        {
            n=yypact[tempstate];
            if (n>PCYYFLAG)    // if statement changed to bypass goto
            {
                if (pcyytoken<0)
                {
                    if ((pcyytoken=yylex())<0)
                    {
                        pcyytoken=0;
                    }
                }
                if ((n+=pcyytoken)>=0&&n<YYLAST)
                {
                    if (yychk[n=yyact[n]]==pcyytoken)
                    {
                        pcyytoken=-1;
						 if (yylval==null) yyval = yylval;
                        else yyval=(imp_union)yylval.clone();
                        tempstate=n;
                        if (pcyyerrfl>0)
                        {
                            pcyyerrfl--;
                        }
                        continue enstack;
                    }
                }
            }
defaultact:
            if ((n=yydef[tempstate])==-2)
            {
                if (pcyytoken<0)
                {
                    if ((pcyytoken=yylex())<0)
                    {
                        pcyytoken=0;
                    }
                }
                for (yyxi=0;(yyexca[yyxi]!=-1)||(yyexca[yyxi+1]!=tempstate);yyxi+=2)
                {
                    n=n;
                }
                while (yyexca[yyxi+=2]>=0)
                {
                    if (yyexca[yyxi]==pcyytoken)
                    {
                        break;
                    }
                }
                if ((n=yyexca[yyxi+1])<0)
                {
                    return 0;
                }
            }
            if (n==0)
            {
                switch (pcyyerrfl)
                {
                    case WAS0ERR:
                        yyerror("syntax error", yydisplay(pcyytoken));
						 if ((n=yypact[tempstate])>PCYYFLAG &&n<YYLAST)
						 {
						     int x;
							 for(x=(n>0)?n:0;x<YYLAST;++x)
							 {
							     if (yychk[yyact[x]]==x-n&&x-n!=YYERRCODE)
									 yyerror(null, yydisplay(x-n));
							 }
							 yyerror(null, null);
						 }
						 yyerror(null, null);
                        pcyyerrcnt++;
                    case WAS1ERR:
                    case WAS2ERR:
                        pcyyerrfl=3;
                        while (yyps>=0)
                        {
                            n=yypact[statestack[yyps]]+YYERRCODE;
                            if (n>=0&&n<YYLAST&&yychk[yyact[n]]==YYERRCODE)
                            {
                                tempstate=yyact[n];
                                continue enstack;
                            }
                            n=yypact[statestack[yyps]];
                            --yyps;
                            --yypv;
                        }
yyabort:
                        return 1;
                    case WAS3ERR:
                        if (pcyytoken==0)
                        {
                            return 1;
                        }
                        pcyytoken=-1;
                        continue newstate;
                    default:
                        break newstate;
                }    // end of switch
            }
            else
            {
                break newstate;    // avoid dead loop.
            }
        }    // end of while at newstate
        yyps-=yyr2[n];
        yypvt=yypv;
        yypv-=yyr2[n];
		if (yyv[yypv+1]==null)
			yyval = yyv[yypv+1];
		else
			yyval=(imp_union)yyv[yypv+1].clone();
        m=n;
        n=yyr1[n];
        j=yypgo[n]+statestack[yyps]+1;
        if ((j>=YYLAST)||(yychk[(tempstate=yyact[j])]!=-n))
        {
            tempstate=yyact[yypgo[n]];
        }
        switch (m)
        {
case 1:

      { prompt(); } break;
      case 2:

      { prompt(); } break;
      case 3:

      { if ( yyv[yypvt-1].db == QUIT) {
      	      return(0);
      	   } else {
      	     System.out.println("  RESULT ====>" + yyv[yypvt-1].db);
      	     System.out.flush();
      	     prompt();
      	   }
      	 } break;
      case 4:

      { yyerrok();
      	     prompt();
      	   } break;
      case 5:

      { yyval.db = yyv[yypvt-0].db; } break;
      case 6:

      { yyval.db = -yyv[yypvt-0].db; } break;
      case 7:

      { yyval.db = yyv[yypvt-2].db + yyv[yypvt-0].db; } break;
      case 8:

      { yyval.db = yyv[yypvt-2].db - yyv[yypvt-0].db; } break;
      case 9:

      { yyval.db = yyv[yypvt-2].db * yyv[yypvt-0].db; } break;
      case 10:

      { yyval.db = yyv[yypvt-2].db / yyv[yypvt-0].db; } break;
      case 11:

      { yyval.db = yyv[yypvt-1].db; } break;    		 }
    } // end of while at enstack
}

// this one used to be a macro
private static void yyerrok()
{
    pcyyerrfl=0;
}

int get_yyerrcnt()
{
	return pcyyerrcnt;
}
}

class imp_union implements Cloneable
{
    double db;
    public Object clone()
    {
      try
      {
        imp_union e = (imp_union)super.clone();
        return e;
      } catch (CloneNotSupportedException e)
      {
        return null;
      }
    }
}

